<?php
/**
 * Szükséges függvények
 * 
 * 
 * @author Takács Ákos (Rimelek), programmer [at] rimelek [dot] hu
 * @author {@link http://www.php.net/manual/hu/function.imagerotate.php#73193 php.net}
 * @package REPHPGraph
 * @filesource
 */
        
        
/**
 * Képforgatás kivétel
 * 
 * @author Takács Ákos (Rimelek), programmer [at] rimelek [dot] hu
 * @copyright Copyright (C) 2008, Takács Ákos
 * @version 1.0
 * @package REPHPGraph
 */
class ImageRotateException extends Exception {
		function __toString() {
			return __CLASS__ . ": [".$this->code."]: ".$this->message."\n";
		}
}
        
if (!function_exists('imagerotate')) {

	/**
	 * Kép elforgatás
	 * 
	 * Abban az esetben, ha nem elérhető az eredeti imageRotate függvény, 
	 * akkor ez a függvény veszi át a helyét.<br />
	 * 
	 * Ez a függvény csak 90, -90 és 180 fokban képes elforgatni a képet.
	 * @author {@link http://www.php.net/manual/hu/function.imagerotate.php#73193 php.net}
	 * @param string $src_img
	 * @param int $angle
	 * @return resource
	 */ 
	function imageRotate($src_img, $angle) {
		$src_x = imagesx($src_img);
		$src_y = imagesy($src_img);
		if ($angle == 90 || $angle == -90) {
			$dest_x = $src_y;
			$dest_y = $src_x;
		} else {
			$dest_x = $src_x;
			$dest_y = $src_y;
		}
		$rotate=imagecreatetruecolor($dest_x,$dest_y);
		imagealphablending($rotate, false);
		
		switch ($angle) {
			case 90:
				for ($y = 0; $y < ($src_y); $y++) {
					for ($x = 0; $x < ($src_x); $x++) {
						$color = imagecolorat($src_img, $x, $y);
						imagesetpixel($rotate, $dest_x - $y - 1, $x, $color);
					}
				}
				break;
			case -90:
				for ($y = 0; $y < ($src_y); $y++) {
					for ($x = 0; $x < ($src_x); $x++) {
						$color = imagecolorat($src_img, $x, $y);
						imagesetpixel($rotate, $y, $dest_y - $x - 1, $color);
					}
				}
				break;
			case 180: case -180:
				for ($y = 0; $y < ($src_y); $y++) {
					for ($x = 0; $x < ($src_x); $x++) {
						$color = imagecolorat($src_img, $x, $y);
							imagesetpixel($rotate, $dest_x - $x - 1, $dest_y - $y - 1, $color);
					}
				}
				break;
			case 0: $rotate = $src_img;
				break;
			default: 
				throw new ImageRotateException("Nem támogatott szög! (".$angle.") Támogatott: 0,90,-90,180");
		}
		return $rotate;
	}
}
?>
